(* Release 3.10 *)(*fix*)(* For CW5 *)
(*-------------------------------------------------------------------------*
*                                                                          *
*  LIB.MOD - General library functions                                     *
*                                                                          *
*  COPYRIGHT (C) 1987..1992 Clarion Software Corporation.                  *
*  All Rights Reserved                                                     *
*                                                                          *
*  Modified for Topspeed Clarion V5.0   CWS    09-26-00                    *
*  Fix register save and restore        CWS    04-16-01                    *
*  Change 'LONGCARD(Var)' to the form 'VAL(LONCARD, Var)'.  CWS  08-17-01  *
*                                                                          *
*--------------------------------------------------------------------------*)

(*# call(o_a_copy => off) *)
(*   # check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)

IMPLEMENTATION MODULE Lib;

IMPORT Str, CWRUN;



TYPE
  Bptr = POINTER TO BYTE;           (* 03-29-99 *)
  Cptr = POINTER TO CARDINAL;       (* 03-29-99 *)

VAR
  FirstTerminate: PROC;                    (* 05-20-99 *)
  PrgReturnCode: SHORTCARD;                (* 05-25-99 *)


  (* These procedures may be in the CWRUN.DLL library *)
  (*  Name: LIB$DOS                      *)
  (*  Name: LIB$HASHSTRING               *)
  (*  Name: LIB$INTR                     *)
  (*  Name: LIB$MOVE                     *)
  (*  Name: LIB$WORDMOVE                 *)


PROCEDURE Move(Source,Dest:ADDRESS; Count:CARDINAL);         (* 03-17-99 *)
BEGIN
  (* IF Count = 0 THEN RETURN; *)
  LOOP     (* Move words by 16 or 32 bits *)
    (* Same as testing __32BIT__ or __WIN32 *) 
    IF Count < SIZE(Dest^) THEN EXIT;  (* 04-01-99 *)
    ELSE
      Dest^ := Source^;
      INC(LONGCARD(Dest),SIZE(Dest^)); INC(LONGCARD(Source),SIZE(Dest^));   (* 04-01-99 *)
      DEC(Count,SIZE(Dest^));
    END;
  END; (* loop *)
  LOOP     (* Move remaining bytes *)  (* 04-01-99 *)
    IF Count = 0 THEN EXIT;
    ELSE
      Bptr(Dest)^ := Bptr(Source)^;    (* 03-29-99 *)
      INC(LONGCARD(Dest)); INC(LONGCARD(Source));   (* 04-01-99 *)
      DEC(Count);                      (* 04-01-99 *)
    END;
  END; (* loop *)
END Move;


PROCEDURE WordMove(Source,Dest:ADDRESS; WordCount:CARDINAL);         (* 04-13-99 *)
VAR Csize: CARDINAL;
BEGIN
  (* IF Count = 0 THEN RETURN; *)
  Csize := SIZE(Dest^) DIV 2;
  LOOP     (* Move words by 16 or 32 bits *)
    (* Same as testing __32BIT__ or __WIN32 *) 
    IF WordCount < Csize THEN EXIT;       (* 04-13-99 *)
    ELSE
      Dest^ := Source^;
      INC(LONGCARD(Dest),SIZE(Dest^)); INC(LONGCARD(Source),SIZE(Dest^));   (* 04-01-99 *)
      DEC(WordCount, Csize);
    END;
  END; (* loop *)
  LOOP     (* Move remaining 16 bit words *)  (* 04-13-99 *)
    IF WordCount = 0 THEN EXIT;
    ELSE
      Cptr(Dest)^ := Cptr(Source)^;    (* 04-13-99 *)
      INC(LONGCARD(Dest),2); INC(LONGCARD(Source),2);   (* 04-01-99 *)
      DEC(WordCount);                      (* 04-01-99 *)
    END;
  END; (* loop *)
END WordMove;


PROCEDURE Fill(Dest: ADDRESS; Count: CARDINAL; Value: BYTE);        (* 03-17-99 *)
BEGIN
  LOOP
    IF Count = 0 THEN RETURN; END;
    Bptr(Dest)^ := Value;
    INC( LONGCARD(Dest) );
    DEC(Count);
  END;
END Fill;


PROCEDURE WordFill(Dest: ADDRESS; WordCount: CARDINAL; Value: CARDINAL);  (* 04-13-99 *)
BEGIN    (* 16 bit words *)
  LOOP
    IF WordCount = 0 THEN RETURN; END;
    Cptr(Dest)^ := Value;
    INC(LONGCARD(Dest), 2);
    DEC(WordCount);
  END;
END WordFill;



PROCEDURE ScanR(Dest: ADDRESS; Count: CARDINAL; Value: BYTE) : CARDINAL;  (* 03-17-99 *)
VAR Ix: CARDINAL;
BEGIN
  FOR Ix := 0 TO Count-1 DO
    IF Bptr(LONGCARD(Dest) + VAL(LONGCARD,Ix))^ = Value THEN RETURN Ix; END;
  END; (* for *)
  RETURN Count;
END ScanR;


PROCEDURE ScanL(Dest: ADDRESS; Count: CARDINAL; Value: BYTE) : CARDINAL;  (* 03-17-99 *)
VAR Ix: CARDINAL;
BEGIN
  FOR Ix := Count-1 TO 0 DO
    IF Bptr(LONGCARD(Dest) + VAL(LONGCARD,Ix))^ = Value THEN RETURN Ix; END;
  END; (* for *)
  RETURN Count;
END ScanL;


PROCEDURE ScanNeR(Dest: ADDRESS; Count: CARDINAL; Value: BYTE) : CARDINAL;  (* 03-17-99 *)
VAR Ix: CARDINAL;
BEGIN
  FOR Ix := 0 TO Count-1 DO
    IF Bptr(LONGCARD(Dest) + VAL(LONGCARD,Ix))^ # Value THEN RETURN Ix; END;
  END; (* for *)
  RETURN Count;
END ScanNeR;


PROCEDURE ScanNeL(Dest: ADDRESS; Count: CARDINAL; Value: BYTE) : CARDINAL;  (* 03-17-99 *)
VAR Ix: CARDINAL;
BEGIN
  FOR Ix := Count-1 TO 0 DO
    IF Bptr(LONGCARD(Dest) + VAL(LONGCARD,Ix))^ # Value THEN RETURN Ix; END;
  END; (* for *)
  RETURN Count;
END ScanNeL;


PROCEDURE Compare(Source,Dest: ADDRESS; Len: CARDINAL) : CARDINAL;      (* 03-17-99 *)
VAR Ndx: CARDINAL;                                     (* 06-25-99 *)
BEGIN
  Ndx := 0;                                            (* 06-25-99 *)
  LOOP
    IF Ndx = Len THEN EXIT; END;                       (* 06-25-99 *)
    IF Bptr(Dest)^ # Bptr(Source)^ THEN RETURN Ndx; END;  (* 06-25-99 *)
    INC(LONGCARD(Dest)); INC(LONGCARD(Source));
    INC(Ndx);                                          (* 06-25-99 *)
  END;
  RETURN Len;
END Compare;



(* Was in AsmLib *)
PROCEDURE Terminate(P: PROC; VAR C: PROC);            (* 05-20-99 *)
BEGIN
  C := FirstTerminate;
  FirstTerminate := P;
END Terminate;





(* Was in AsmLib *)
PROCEDURE SetReturnCode(code: SHORTCARD);       (* 03-30-99 *)
BEGIN
  PrgReturnCode := code;                        (* 05-25-99 *)
END SetReturnCode;




PROCEDURE Sound(FreqHz: CARDINAL);              (* 06-10-99 *)
BEGIN
 CWRUN.BEEP(150, CWRUN.BEEPHand);   (* =150, =16 *)  (* 06-10-99 *)
END Sound;



PROCEDURE NoSound();                              (* 06-10-99 *)
BEGIN
END NoSound;



PROCEDURE Delay(Time: CARDINAL);                (* 06-10-99 *)
BEGIN
  CWRUN.YIELD();   (* patched out *)
END Delay;



PROCEDURE IsOfClass(Child, Parent: MTablePtr): BOOLEAN;

VAR
    ThisObject: MTablePtr;

BEGIN
    ThisObject:= Child;
    IF ThisObject = Parent THEN RETURN TRUE END;
    WHILE ThisObject^.Parent # NIL DO
        IF ThisObject^.Parent = Parent THEN RETURN TRUE END;
        ThisObject := ThisObject^.Parent;
    END;
    RETURN FALSE;
END IsOfClass;



PROCEDURE HSort(N: CARDINAL; Less: CompareProc; Swap: SwapProc);
VAR
  i,j,k : CARDINAL;
BEGIN
  IF N > 1 THEN
    i := N DIV 2;
    REPEAT
      j := i;
      LOOP (* Note that total repeats <= N/4 * 1 + N/8 * 2 + N/16 * 3 + .... *)
        k := j * 2;
        IF k > N THEN EXIT END;
        IF (k < N) AND Less(k,k+1) THEN INC(k) END;
        IF Less(j,k) THEN Swap(j,k) ELSE EXIT END;
        j := k;
      END;
      DEC(i);
    UNTIL i = 0;

    i := N;
    REPEAT
      j := 1;
      Swap(j,i);
      DEC(i);
      LOOP
        k := j * 2;
        IF k > i THEN EXIT END;
        IF ( k < i ) AND Less(k,k+1) THEN INC(k) END;
        Swap(j,k);
        j := k;
      END;
      LOOP
        k := j DIV 2;
        IF (k > 0) AND Less(k,j) THEN Swap(j,k); j := k ELSE EXIT END;
      END;
    UNTIL i = 0;
  END;
END HSort;


PROCEDURE QSort(N: CARDINAL; Less: CompareProc; Swap: SwapProc);

  PROCEDURE Sort(l,r: CARDINAL);
  VAR
    i,j:CARDINAL;
  BEGIN
    WHILE r > l DO
      i := l+1;
      j := r;
      WHILE i <= j DO
        WHILE (i <= j) AND NOT Less(l,i) DO INC(i) END;
        WHILE (i <= j) AND Less(l,j) DO DEC(j) END;
        IF i <= j THEN Swap(i,j); INC(i); DEC(j) END;
      END;
      IF j # l THEN Swap(j,l) END;
      IF j+j > r+l THEN (* small one recursively *)
        Sort(j+1,r);
        r := j-1;
      ELSE
        Sort(l,j-1);
        l := j+1;
      END;
    END;
  END Sort;

BEGIN
  Sort(1,N);
END QSort;


CONST
  HistoryMax = 54;

VAR
  HistoryPtr : CARDINAL;
  LowerPtr   : CARDINAL;
  History    : ARRAY [0..HistoryMax] OF CARDINAL;

  PROCEDURE SEED(v:CARDINAL);
    VAR
      x                 : LONGCARD;
      i                 : CARDINAL;
    BEGIN
      HistoryPtr := HistoryMax;
      LowerPtr := 23;
      x := VAL(LONGCARD, v);                     (* 08-17-01 *)
      i := 0;
      REPEAT
        x := (x*3141592621+17);
        History[i] := CARDINAL(x DIV 10000H);
        INC(i);
      UNTIL i > HistoryMax;
    END SEED;

PROCEDURE RANDOM(Range: CARDINAL) : CARDINAL;
VAR res:CARDINAL;
BEGIN
  IF HistoryPtr = 0 THEN
    IF LowerPtr = 0 THEN
      SEED(12345);
    ELSE
      HistoryPtr := HistoryMax;
      LowerPtr   := LowerPtr-1;
    END;
  ELSE
    HistoryPtr := HistoryPtr-1;
    IF LowerPtr = 0 THEN
      LowerPtr := HistoryMax;
    ELSE
      LowerPtr := LowerPtr-1;
    END;
  END;
  res := History[HistoryPtr]+History[LowerPtr];
  History[HistoryPtr] := res;
  IF Range = 0 THEN
    RETURN res;
  ELSE
    RETURN res MOD Range;
  END;
END RANDOM;


PROCEDURE RANDOMIZE();
  BEGIN
    SEED(CARDINAL(CWRUN.TODAY()));            (* 04-06-99 *)
END RANDOMIZE;


PROCEDURE RAND(): REAL;
VAR
  x:RECORD low,high:CARDINAL END;
BEGIN
  x.low := RANDOM(0);
  x.high := RANDOM(0);
  RETURN FLOAT(LONGCARD(x))/(FLOAT(MAX(LONGCARD))+1.1);  (* NB Temp Fix *)  (* 08-17-01 *)
END RAND;



PROCEDURE FatalError(S : ARRAY OF CHAR);

BEGIN
  CWRUN.HALT(2, S);                (* 04-06-99 *)
END FatalError;



PROCEDURE RunTimeErrorHandler(ErrAdd: LONGCARD; Code: CARDINAL; Msg: ARRAY OF CHAR);  (* 04-13-99 *)
VAR ErStr: ARRAY[0..127] OF CHAR;  ok: BOOLEAN;
BEGIN
  Str.CardToStr(ErrAdd,ErStr,16,ok);
  Str.Prepend(ErStr,"Fatal Error at ");
  Str.Append(ErStr, Msg);
  CWRUN.HALT(2, Msg);                (* 04-13-99 *)
END RunTimeErrorHandler;



PROCEDURE SysErrno(): CARDINAL;                          (* 09-28-99 *)
BEGIN
  RETURN CWRUN.ERRORCODE();
END SysErrno;




PROCEDURE MakeAllPath(VAR Path: ARRAY OF CHAR; Drive, Dir, Name, Ext: ARRAY OF CHAR);

VAR
   Pos: CARDINAL;
BEGIN
    Str.Copy(Path, Drive);
    IF Dir[0] # CHAR(0) THEN
        Str.Append(Path, Dir);
        Pos:=Str.Length(Path)-1;
        IF NOT((Path[Pos] = '\') OR (Path[Pos] = '/')) THEN
            Path[Pos+1]:='\';
            Path[Pos+2]:=CHAR(0);
        END;
    END;
    Str.Append(Path, Name);
    IF Ext[0] # CHAR(0) THEN
        IF Ext[0] # '.'THEN
            Pos:=Str.Length(Path);
            Path[Pos]:='.';
            Path[Pos+1]:=CHAR(0);
        END;
        Str.Append(Path, Ext);
    END;
    RETURN;
END MakeAllPath;


PROCEDURE SplitAllPath(Path: ARRAY OF CHAR; VAR Drive: ARRAY OF CHAR;
                    VAR Dir: ARRAY OF CHAR; VAR Name: ARRAY OF CHAR; VAR Ext: ARRAY OF CHAR);

VAR
    n, p: CARDINAL;
    Dir_start, Name_start, Ext_start, Path_end: CARDINAL;
    c: CHAR;
BEGIN
    n := 0;
    IF (Path[0] # 0C) AND ((Path[1] = ':') OR (Path[2] = ':')) THEN
      REPEAT
        c := Path[n];
        Drive[n] := c;
        INC(n);
      UNTIL ((c = ':') OR (n > HIGH(Drive)));
    END;
    IF n <= HIGH(Drive) THEN
      Drive[n] := 0C;
    END;
    Dir_start := n;
    Name_start := n;
    Ext_start := MAX(CARDINAL);
    LOOP
      c := Path[n];
      IF c = 0C THEN EXIT END;
      CASE c OF
       | '.' :
          IF(NOT((Path[n+1] = '.') OR (Path[n+1] = '\') OR (Path[n+1] = '/'))) THEN
            Ext_start := n;
          END;
          INC(n);
       | '/', '\' :
          INC(n);
          Name_start := n;
       ELSE
          INC(n);
      END;
    END;
    Path_end := n;
    IF Ext_start = MAX(CARDINAL) THEN
      Ext_start := n;
    END;
    n:= Dir_start;
    p := 0;
    WHILE ((n < Name_start) AND (p <= HIGH(Dir)) AND (n<Ext_start)) DO
      Dir[p] := Path[n];
      INC(p);
      INC(n);
    END;
    IF p <= HIGH(Dir) THEN
      Dir[p] := 0C;
    END;
    n := Name_start;
    p := 0;
    WHILE (n < Ext_start) AND (p <= HIGH(Name)) DO
      Name[p] := Path[n];
      INC(n);
      INC(p);
    END;
    IF p <= HIGH(Name) THEN
      Name[p] := 0C;
    END;
    p := 0;
    IF(Ext_start >= Name_start) THEN
      n := Ext_start;
      WHILE (n < Path_end) AND (p <= HIGH(Ext)) DO
        Ext[p] := Path[n];
        INC(n);
        INC(p);
      END;
    END;
    IF p <= HIGH(Ext) THEN
      Ext[p] := 0C;
    END;
END SplitAllPath;




(* ------- Special Clarion procedures ------- *)

    (*    Save DI, SI, BX, DX, CX, DS, ES,     FS,     GS *)
    (*         57H,56H,53H,52H,51H,1EH,06H,0FH,0AH,0FH,A8H *)
    (* Restore GS,     FS,     ES, DS, CX, DX, BX, SI, DI *)
    (*         0FH,A9H,0FH,A1H,07H,1FH,59H,5AH,5BH,5EH,5FH *)
    (* Pusha  60H,     popa  61H  *)

(* Using call(reg_saved=>()) Did Not Work *)
(*# save,call(inline=>on) *)
 TYPE Hex_ = ARRAY[0..6] OF BYTE;                             (* 04-16-01 *)
 (* These instructions act the same in 32 bit mode, no need for __32BIT__. *)
  INLINE PROCEDURE PushReg() = Hex_(60H,1EH,06H,0FH,0A0H,0FH,0A8H); (* Save All *)  (* 04-16-01 *)
  INLINE PROCEDURE PopReg()  = Hex_(0FH,0A9H,0FH,0A1H,07H,1FH,61H); (* Restore All *)  (* 04-16-01 *)
(*# restore *)

(* Call one of the Modula-2 initialize vectors *)
PROCEDURE CallInitProc(Iproc: LONGCARD);                  (* 04-23-99 *)
VAR InitProc: PROC;
BEGIN
  InitProc := PROC(Iproc);                                (* 04-23-99 *)
  PushReg();                                 (* 05-10-99 *)
  InitProc();
  PopReg();                                  (* 05-10-99 *)
END CallInitProc;




(* Call all of the Modula-2 terminate procedures *)
PROCEDURE CallTerminateProcs();                           (* 05-20-99 *)
BEGIN
  PushReg();                                 (* 09-26-00 *)
  FirstTerminate();                         (* 05-25-99 *)
  PopReg();                                  (* 09-26-00 *)
END CallTerminateProcs;



PROCEDURE EndOfTerminate();                   (* 05-25-99 *)
BEGIN
  (* Halt not called here *)
END EndOfTerminate;




(*#save *)
(*#name (prefix=>none) *)
PROCEDURE Standard$NULLPROC();                (* 04-06-99 *)
BEGIN
  CWRUN.HALT(2, "NullProc Called");         (* 04-06-99 *)
END Standard$NULLPROC;
(*#restore *)



BEGIN  (* Init *)
  HistoryPtr     := 0;
  LowerPtr       := 0;
  NilStr[0]      := 0C;
  RunTimeError:=RunTimeErrorHandler;        (* 04-13-99 *)
  FirstTerminate := EndOfTerminate;         (* 05-25-99 *)
  PrgReturnCode  := 0;                      (* 05-25-99 *)

END Lib.
